import org.antlr.runtime.ANTLRInputStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.tree.CommonTree;
import org.antlr.runtime.tree.CommonTreeNodeStream;

public class Engine {
	public static SymbolTable	symtab = new SymbolTable();
	public static Gen			gen = new Gen();
	
    public static void main(String[] args) throws Exception {
        ANTLRInputStream input = new ANTLRInputStream(System.in);
        SampleCLexer lexer = new SampleCLexer(input);
        CommonTokenStream tokens = new CommonTokenStream(lexer);
        SampleCParser parser = new SampleCParser(tokens);
        SampleCParser.program_return r = parser.program();
  
        CommonTree t = (CommonTree)r.getTree();
        CommonTreeNodeStream nodes = new CommonTreeNodeStream(t);
        //Function Identification
        FunctionID f_walker = new FunctionID(nodes);
        f_walker.program();
        //Interperter
        nodes = new CommonTreeNodeStream(t);
        Interpreter walker = new Interpreter(nodes);
        walker.program();
    }
}